## arm-compute-library 19.11

=== SConstruct ===
# Copyright (c) 2016, 2017 ARM Limited.
#
# SPDX-License-Identifier: MIT
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to
# deal in the Software without restriction, including without limitation the
# rights to use, copy, modify, merge, publish, distribute, sublicense, and/or
# sell copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.

import SCons
import os
import subprocess

def version_at_least(version, required):
    end = min(len(version), len(required))

    for i in range(0, end, 2):
        if int(version[i]) < int(required[i]):
            return False
        elif int(version[i]) > int(required[i]):
            return True

    return True

vars = Variables("scons")
vars.AddVariables(
    BoolVariable("debug", "Debug", False),
    BoolVariable("asserts", "Enable asserts (this flag is forced to 1 for debug=1)", False),
    BoolVariable("logging", "Logging (this flag is forced to 1 for debug=1)", False),
    EnumVariable("arch", "Target Architecture", "armv7a", allowed_values=("armv7a", "arm64-v8a", "arm64-v8.2-a", "arm64-v8.2-a-sve", "x86_32", "x86_64")),
    EnumVariable("os", "Target OS", "linux", allowed_values=("linux", "android", "bare_metal")),
    EnumVariable("build", "Build type", "cross_compile", allowed_values=("native", "cross_compile", "embed_only")),
    BoolVariable("examples", "Build example programs", True),
    BoolVariable("gemm_tuner", "Build gemm_tuner programs", True),
    BoolVariable("Werror", "Enable/disable the -Werror compilation flag", True),
    BoolVariable("standalone", "Builds the tests as standalone executables, links statically with libgcc, libstdc++ and libarm_compute", False),
    BoolVariable("opencl", "Enable OpenCL support", True),
    BoolVariable("neon", "Enable Neon support", False),
    BoolVariable("gles_compute", "Enable OpenGL ES Compute Shader support", False),
    BoolVariable("embed_kernels", "Embed OpenCL kernels and OpenGL ES compute shaders in library binary", True),
    BoolVariable("set_soname", "Set the library's soname and shlibversion (requires SCons 2.4 or above)", False),
    BoolVariable("openmp", "Enable OpenMP backend", False),
    BoolVariable("cppthreads", "Enable C++11 threads backend", True),
    PathVariable("build_dir", "Specify sub-folder for the build", ".", PathVariable.PathAccept),
    PathVariable("install_dir", "Specify sub-folder for the install", "", PathVariable.PathAccept),
    BoolVariable("exceptions", "Enable/disable C++ exception support", True),
    ("toolchain_prefix", "Override the toolchain prefix", ""),
    ("extra_cxx_flags", "Extra CXX flags to be appended to the build command", ""),
    ("extra_link_flags", "Extra LD flags to be appended to the build command", ""),
    ("compiler_cache", "Command to prefix to the C and C++ compiler (e.g ccache)", "")
)

env = Environment(platform="posix", variables=vars, ENV = os.environ)
build_path = env['build_dir']
# If build_dir is a relative path then add a #build/ prefix:
if not env['build_dir'].startswith('/'):
    SConsignFile('build/%s/.scons' % build_path)
    build_path = "#build/%s" % build_path
else:
    SConsignFile('%s/.scons' % build_path)

install_path = env['install_dir']
#If the install_dir is a relative path then assume it's from inside build_dir
if not env['install_dir'].startswith('/') and install_path != "":
    install_path = "%s/%s" % (build_path, install_path)

env.Append(LIBPATH = [build_path])
Export('env')
Export('vars')

def install_lib( lib ):
    # If there is no install folder, then there is nothing to do:
    if install_path == "":
        return lib
    return env.Install( "%s/lib/" % install_path, lib)
def install_bin( bin ):
    # If there is no install folder, then there is nothing to do:
    if install_path == "":
        return bin
    return env.Install( "%s/bin/" % install_path, bin)
def install_include( inc ):
    if install_path == "":
        return inc
    return env.Install( "%s/include/" % install_path, inc)

Export('install_lib')
Export('install_bin')

Help(vars.GenerateHelpText(env))

if env['build'] == "embed_only":
    SConscript('./SConscript', variant_dir=build_path, duplicate=0)
    Return()

if env['neon'] and 'x86' in env['arch']:
    print("Cannot compile NEON for x86")
    Exit(1)

if env['set_soname'] and not version_at_least(SCons.__version__, "2.4"):
    print("Setting the library's SONAME / SHLIBVERSION requires SCons 2.4 or above")
    print("Update your version of SCons or use set_soname=0")
    Exit(1)

if env['os'] == 'bare_metal':
    if env['cppthreads'] or env['openmp']:
         print("ERROR: OpenMP and C++11 threads not supported in bare_metal. Use cppthreads=0 openmp=0")
         Exit(1)

if not env['exceptions']:
    if env['opencl'] or env['gles_compute']:
         print("ERROR: OpenCL and GLES are not supported when building without exceptions. Use opencl=0 gles_compute=0")
         Exit(1)

    env.Append(CPPDEFINES = ['ARM_COMPUTE_EXCEPTIONS_DISABLED'])
    env.Append(CXXFLAGS = ['-fno-exceptions'])

env.Append(CXXFLAGS = ['-Wall','-DARCH_ARM',
         '-Wextra','-pedantic','-Wdisabled-optimization','-Wformat=2',
         '-Winit-self','-Wstrict-overflow=2','-Wswitch-default',
         '-fpermissive','-std=gnu++11','-Woverloaded-virtual', '-Wformat-security',
         '-Wctor-dtor-privacy','-Wsign-promo','-Weffc++','-Wno-overlength-strings'])

env.Append(CPPDEFINES = ['_GLIBCXX_USE_NANOSLEEP'])

default_cpp_compiler = 'g++' if env['os'] != 'android' else 'clang++'
default_c_compiler = 'gcc' if env['os'] != 'android' else 'clang'
cpp_compiler = os.environ.get('CXX', default_cpp_compiler)
c_compiler = os.environ.get('CC', default_c_compiler)

if env['os'] == 'android' and ( 'clang++' not in cpp_compiler or 'clang' not in c_compiler ):
    print( "WARNING: Only clang is officially supported to build the Compute Library for Android")

if 'clang++' in cpp_compiler:
    env.Append(CXXFLAGS = ['-Wno-vla-extension'])
elif 'armclang' in cpp_compiler:
    pass
else:
    env.Append(CXXFLAGS = ['-Wlogical-op','-Wnoexcept','-Wstrict-null-sentinel'])

if env['cppthreads']:
    env.Append(CPPDEFINES = [('ARM_COMPUTE_CPP_SCHEDULER', 1)])

if env['openmp']:
    if 'clang++' in cpp_compiler:
        print( "Clang does not support OpenMP. Use scheduler=cpp.")
        Exit(1)

    env.Append(CPPDEFINES = [('ARM_COMPUTE_OPENMP_SCHEDULER', 1)])
    env.Append(CXXFLAGS = ['-fopenmp'])
    env.Append(LINKFLAGS = ['-fopenmp'])

# Add architecture specific flags
prefix = ""
if env['arch'] == 'armv7a':
    env.Append(CXXFLAGS = ['-march=armv7-a', '-mthumb', '-mfpu=neon'])

    if env['os'] == 'linux':
        prefix = "arm-linux-gnueabihf-"
        env.Append(CXXFLAGS = ['-mfloat-abi=hard'])
    elif env['os'] == 'bare_metal':
        prefix = "arm-eabi-"
        env.Append(CXXFLAGS = ['-mfloat-abi=hard'])
    elif env['os'] == 'android':
        prefix = "arm-linux-androideabi-"
        env.Append(CXXFLAGS = ['-mfloat-abi=softfp'])
elif env['arch'] == 'arm64-v8a':
    env.Append(CXXFLAGS = ['-march=armv8-a'])
    env.Append(CPPDEFINES = ['ARM_COMPUTE_AARCH64_V8A'])
    if env['os'] == 'linux':
        prefix = "aarch64-linux-gnu-"
    elif env['os'] == 'bare_metal':
        prefix = "aarch64-elf-"
    elif env['os'] == 'android':
        prefix = "aarch64-linux-android-"
elif 'arm64-v8.2-a' in env['arch']:
    if env['arch'] == 'arm64-v8.2-a-sve':
        env.Append(CXXFLAGS = ['-march=armv8.2-a+sve+fp16+dotprod'])
    else:
        env.Append(CXXFLAGS = ['-march=armv8.2-a+fp16']) # explicitly enable fp16 extension otherwise __ARM_FEATURE_FP16_VECTOR_ARITHMETIC is undefined
    if env['os'] == 'linux':
        prefix = "aarch64-linux-gnu-"
    elif env['os'] == 'bare_metal':
        prefix = "aarch64-elf-"
    elif env['os'] == 'android':
        prefix = "aarch64-linux-android-"
    env.Append(CPPDEFINES = ['ARM_COMPUTE_AARCH64_V8_2'])
elif env['arch'] == 'x86_32':
    env.Append(CCFLAGS = ['-m32'])
    env.Append(LINKFLAGS = ['-m32'])
elif env['arch'] == 'x86_64':
    env.Append(CXXFLAGS = ['-fPIC'])
    env.Append(CCFLAGS = ['-m64'])
    env.Append(LINKFLAGS = ['-m64'])

if env['build'] == 'native':
    prefix = ""

if env["toolchain_prefix"] != "":
    prefix = env["toolchain_prefix"]

env['CC'] = env['compiler_cache']+" "+prefix + c_compiler
env['CXX'] = env['compiler_cache']+" "+prefix + cpp_compiler
env['LD'] = prefix + "ld"
env['AS'] = prefix + "as"
env['AR'] = prefix + "ar"
env['RANLIB'] = prefix + "ranlib"

if not GetOption("help"):
    try:
        compiler_ver = subprocess.check_output(env['CXX'].split() + ["-dumpversion"]).strip()
    except OSError:
        print("ERROR: Compiler '%s' not found" % env['CXX'])
        Exit(1)

    if 'armclang' in cpp_compiler:
        pass
    elif 'clang++' not in cpp_compiler:
        if env['arch'] == 'arm64-v8.2-a' and not version_at_least(compiler_ver, '6.2.1'):
            print("GCC 6.2.1 or newer is required to compile armv8.2-a code")
            Exit(1)
        elif env['arch'] == 'arm64-v8a' and not version_at_least(compiler_ver, '4.9'):
            print("GCC 4.9 or newer is required to compile NEON code for AArch64")
            Exit(1)

        if version_at_least(compiler_ver, '6.1'):
            env.Append(CXXFLAGS = ['-Wno-ignored-attributes'])

        if compiler_ver == '4.8.3':
            env.Append(CXXFLAGS = ['-Wno-array-bounds'])

if env['standalone']:
    env.Append(CXXFLAGS = ['-fPIC'])
    env.Append(LINKFLAGS = ['-static-libgcc','-static-libstdc++'])

if env['Werror']:
    env.Append(CXXFLAGS = ['-Werror'])

if env['os'] == 'android':
    env.Append(CPPDEFINES = ['ANDROID'])
    env.Append(LINKFLAGS = ['-pie', '-static-libstdc++'])
elif env['os'] == 'bare_metal':
    env.Append(LINKFLAGS = ['-static'])
    env.Append(LINKFLAGS = ['-specs=rdimon.specs'])
    env.Append(CXXFLAGS = ['-fPIC'])
    env.Append(CPPDEFINES = ['NO_MULTI_THREADING'])
    env.Append(CPPDEFINES = ['BARE_METAL'])

if env['opencl']:
    if env['os'] in ['bare_metal'] or env['standalone']:
        print("Cannot link OpenCL statically, which is required for bare metal / standalone builds")
        Exit(1)

if env['gles_compute']:
    if env['os'] in ['bare_metal'] or env['standalone']:
        print("Cannot link OpenGLES statically, which is required for bare metal / standalone builds")
        Exit(1)

if env["os"] not in ["android", "bare_metal"] and (env['opencl'] or env['cppthreads']):
    env.Append(LIBS = ['pthread'])

if env['opencl'] or env['gles_compute']:
    if env['embed_kernels']:
        env.Append(CPPDEFINES = ['EMBEDDED_KERNELS'])

if env['debug']:
    env['asserts'] = True
    env['logging'] = True
    env.Append(CXXFLAGS = ['-O0','-g','-gdwarf-2'])
    env.Append(CPPDEFINES = ['ARM_COMPUTE_DEBUG_ENABLED'])
else:
    env.Append(CXXFLAGS = ['-O3'])

if env['asserts']:
    env.Append(CPPDEFINES = ['ARM_COMPUTE_ASSERTS_ENABLED'])
    env.Append(CXXFLAGS = ['-fstack-protector-strong'])

if env['logging']:
    env.Append(CPPDEFINES = ['ARM_COMPUTE_LOGGING_ENABLED'])

env.Append(CPPPATH = ['#/include', "#"])
env.Append(CXXFLAGS = env['extra_cxx_flags'])
env.Append(LINKFLAGS = env['extra_link_flags'])

Default( install_include("arm_compute"))

=== debian/changelog ===
arm-compute-library (19.11-1) unstable; urgency=low

  * Initial release (Closes: #946273)

 -- Compute Library Team <developer-compute@arm.com>  Thu, 31 Oct 2019 13:18:35 +0000

=== debian/control ===
Source: arm-compute-library
Section: libs
Priority: optional
Maintainer: Compute Library Team <developer-compute@arm.com>
Uploaders: Georgios Pinitas <georgios.pinitas@arm.com>,
Standards-Version: 4.3.0
Homepage: https://github.com/ARM-software/ComputeLibrary
Build-Depends: debhelper-compat (= 12),
               dh-exec (>=0.3),
               scons (>= 2.4),
               doxygen,
               graphviz

Package: libarm-compute17
Architecture: armhf arm64
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Arm Compute Library
 Arm Compute Library is a software library for computer vision and
 machine learning.  It is a collection of low-level functions
 optimized for Arm CPU and GPU architectures targeted at image
 processing, computer vision, and machine learning.  Arm Compute
 Library is usable as a shared or static library.
 .
 Both 32 and 64-bit variants are supported. (ARM v7, 32-bit, armhf,
 and ARM v8, 64-bit, aarch64/arm64)

Package: libarm-compute-dev
Section: libdevel
Architecture: armhf arm64
Multi-Arch: same
Depends: libarm-compute17 (= ${binary:Version}), ${misc:Depends}
Suggests: libarm-compute-doc (= ${source:Version})
Description: Arm Compute Library - development files
 Arm Compute Library is a software library for computer vision and
 machine learning.  It is a collection of low-level functions
 optimized for Arm CPU and GPU architectures targeted at image
 processing, computer vision, and machine learning.  Arm Compute
 Library is usable as a shared or static library.
 .
 Both 32 and 64-bit variants are supported: armhf (ARM v7, 32-bit),
 and arm64 (ARM v8, 64-bit, aarch64)
 .
 This package contains the development files (headers, static library)

Package: libarm-compute-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}, libjs-mathjax
Multi-Arch: foreign
Description: Arm Compute Library - documentation
 Arm Compute Library is a software library for computer vision and
 machine learning.  It is a collection of low-level functions
 optimized for Arm CPU and GPU architectures targeted at image
 processing, computer vision, and machine learning.  Arm Compute
 Library is usable as a shared or static library.
 .
 Both 32 and 64-bit variants are supported: armhf (ARM v7, 32-bit),
 and arm64 (ARM v8, 64-bit, aarch64)
 .
 This package contains the Compute Library documentation as HTML.

=== debian/rules ===
#!/usr/bin/make -f
# See debhelper(7) (uncomment to enable)
# output every command that modifies files on the build system.
DH_VERBOSE = 1

# see EXAMPLES in dpkg-buildflags(1) and read /usr/share/dpkg/*
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/default.mk

%:
	dh $@

ifeq ($(DEB_TARGET_ARCH),armhf)
ACL_ARCH := armv7a
else ifeq ($(DEB_TARGET_ARCH),arm64)
ACL_ARCH := arm64-v8a
else
	@echo "Unknown architecture $(DEB_TARGET_ARCH)"
	@echo "This package can only be built for armhf and arm64"
	exit 1
endif

VERSION=$(shell dpkg-parsechangelog -S version | awk '{split($$0,a,"-"); print a[1]}')

SCONS=scons
OPTIONS := arch=$(ACL_ARCH) opencl=1 neon=1 gles_compute=0 asserts=0 debug=0 Werror=0 os=linux build=native embed_kernels=1 set_soname=1 validation_tests=0 benchmark_tests=0
# Build log should be verbose unless 'terse' is set
ifneq (,$(filter terse,$(DEB_BUILD_OPTIONS)))
    OPTIONS += -s
endif

ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
    NUMJOBS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
    OPTIONS += -j$(NUMJOBS)
endif
# support nostrip and debug too?

override_dh_auto_build-arch: 
	$(SCONS) $(OPTIONS) install_dir=install
	# Generate pkgconfig files
	for lib in arm_compute arm_compute_core arm_compute_graph; do \
	sed -e "s/@DEB_HOST_MULTIARCH@/$(DEB_HOST_MULTIARCH)/" < debian/lib$${lib}.pc.in > debian/$${lib}.pc && \
	sed -i -e "s:@VERSION@:$(VERSION):" debian/$${lib}.pc; \
	done

override_dh_auto_build-indep: 
	mkdir -p build/docs
	doxygen docs/Doxyfile && touch debian/docs.stamp

DOCDIR=debian/tmp
override_dh_auto_install-indep: debian/docs.stamp
	mkdir -p $(DOCDIR)
	cp -a --reflink=auto build/docs/html $(DOCDIR)
	cp -a debian/ACL_logo.png $(DOCDIR)

override_dh_auto_clean:
	dh_auto_clean
	rm -rf build
	rm -rf documentation
	rm -rf .sconf_tem/ .sconsign.dblite config.log
	rm -f debian/arm_*.pc
	rm -f debian/docs.stamp

## arm-compute-library 20.08+dfsg

=== SConstruct ===
--- 
+++ 
@@ -1,4 +1,4 @@
-# Copyright (c) 2016, 2017 ARM Limited.
+# Copyright (c) 2016, 2017 Arm Limited.
 #
 # SPDX-License-Identifier: MIT
 #
@@ -40,8 +40,11 @@
     BoolVariable("debug", "Debug", False),
     BoolVariable("asserts", "Enable asserts (this flag is forced to 1 for debug=1)", False),
     BoolVariable("logging", "Logging (this flag is forced to 1 for debug=1)", False),
-    EnumVariable("arch", "Target Architecture", "armv7a", allowed_values=("armv7a", "arm64-v8a", "arm64-v8.2-a", "arm64-v8.2-a-sve", "x86_32", "x86_64")),
-    EnumVariable("os", "Target OS", "linux", allowed_values=("linux", "android", "bare_metal")),
+    EnumVariable("arch", "Target Architecture", "armv7a",
+                  allowed_values=("armv7a", "arm64-v8a", "arm64-v8.2-a", "arm64-v8.2-a-sve", "x86_32", "x86_64",
+                                  "armv8a", "armv8.2-a", "armv8.2-a-sve", "armv8.6-a", "x86")),
+    EnumVariable("estate", "Execution State", "auto", allowed_values=("auto", "32", "64")),
+    EnumVariable("os", "Target OS", "linux", allowed_values=("linux", "android", "tizen", "bare_metal")),
     EnumVariable("build", "Build type", "cross_compile", allowed_values=("native", "cross_compile", "embed_only")),
     BoolVariable("examples", "Build example programs", True),
     BoolVariable("gemm_tuner", "Build gemm_tuner programs", True),
@@ -52,12 +55,15 @@
     BoolVariable("gles_compute", "Enable OpenGL ES Compute Shader support", False),
     BoolVariable("embed_kernels", "Embed OpenCL kernels and OpenGL ES compute shaders in library binary", True),
     BoolVariable("set_soname", "Set the library's soname and shlibversion (requires SCons 2.4 or above)", False),
+    BoolVariable("tracing", "Enable runtime tracing", False),
     BoolVariable("openmp", "Enable OpenMP backend", False),
     BoolVariable("cppthreads", "Enable C++11 threads backend", True),
     PathVariable("build_dir", "Specify sub-folder for the build", ".", PathVariable.PathAccept),
     PathVariable("install_dir", "Specify sub-folder for the install", "", PathVariable.PathAccept),
     BoolVariable("exceptions", "Enable/disable C++ exception support", True),
+    PathVariable("linker_script", "Use an external linker script", "", PathVariable.PathAccept),
     ("toolchain_prefix", "Override the toolchain prefix", ""),
+    ("compiler_prefix", "Override the compiler prefix", ""),
     ("extra_cxx_flags", "Extra CXX flags to be appended to the build command", ""),
     ("extra_link_flags", "Extra LD flags to be appended to the build command", ""),
     ("compiler_cache", "Command to prefix to the C and C++ compiler (e.g ccache)", "")
@@ -101,6 +107,10 @@
 
 Help(vars.GenerateHelpText(env))
 
+if env['linker_script'] and env['os'] != 'bare_metal':
+    print("Linker script is only supported for bare_metal builds")
+    Exit(1)
+
 if env['build'] == "embed_only":
     SConscript('./SConscript', variant_dir=build_path, duplicate=0)
     Return()
@@ -130,7 +140,7 @@
 env.Append(CXXFLAGS = ['-Wall','-DARCH_ARM',
          '-Wextra','-pedantic','-Wdisabled-optimization','-Wformat=2',
          '-Winit-self','-Wstrict-overflow=2','-Wswitch-default',
-         '-fpermissive','-std=gnu++11','-Woverloaded-virtual', '-Wformat-security',
+         '-std=gnu++11','-Woverloaded-virtual', '-Wformat-security',
          '-Wctor-dtor-privacy','-Wsign-promo','-Weffc++','-Wno-overlength-strings'])
 
 env.Append(CPPDEFINES = ['_GLIBCXX_USE_NANOSLEEP'])
@@ -162,48 +172,70 @@
     env.Append(CXXFLAGS = ['-fopenmp'])
     env.Append(LINKFLAGS = ['-fopenmp'])
 
+# Validate and define state
+if env['estate'] == 'auto':
+    if 'v7a' in env['arch']:
+        env['estate'] = '32'
+    else:
+        env['estate'] = '64'
+
+# Map legacy arch
+if 'arm64' in env['arch']:
+    env['estate'] = '64'
+
+if 'v7a' in env['estate'] and env['estate'] == '64':
+    print("ERROR: armv7a architecture has only 32-bit execution state")
+    Exit(1)
+
 # Add architecture specific flags
 prefix = ""
-if env['arch'] == 'armv7a':
+if 'v7a' in env['arch']:
     env.Append(CXXFLAGS = ['-march=armv7-a', '-mthumb', '-mfpu=neon'])
-
-    if env['os'] == 'linux':
-        prefix = "arm-linux-gnueabihf-"
+    if env['os'] == 'android' or env['os'] == 'tizen':
+        env.Append(CXXFLAGS = ['-mfloat-abi=softfp'])
+    else:
         env.Append(CXXFLAGS = ['-mfloat-abi=hard'])
-    elif env['os'] == 'bare_metal':
-        prefix = "arm-eabi-"
-        env.Append(CXXFLAGS = ['-mfloat-abi=hard'])
-    elif env['os'] == 'android':
-        prefix = "arm-linux-androideabi-"
-        env.Append(CXXFLAGS = ['-mfloat-abi=softfp'])
-elif env['arch'] == 'arm64-v8a':
-    env.Append(CXXFLAGS = ['-march=armv8-a'])
-    env.Append(CPPDEFINES = ['ARM_COMPUTE_AARCH64_V8A'])
-    if env['os'] == 'linux':
-        prefix = "aarch64-linux-gnu-"
-    elif env['os'] == 'bare_metal':
-        prefix = "aarch64-elf-"
-    elif env['os'] == 'android':
-        prefix = "aarch64-linux-android-"
-elif 'arm64-v8.2-a' in env['arch']:
-    if env['arch'] == 'arm64-v8.2-a-sve':
+elif 'v8' in env['arch']:
+    if 'sve' in env['arch']:
         env.Append(CXXFLAGS = ['-march=armv8.2-a+sve+fp16+dotprod'])
-    else:
+    elif 'v8.2-a' in env['arch']:
         env.Append(CXXFLAGS = ['-march=armv8.2-a+fp16']) # explicitly enable fp16 extension otherwise __ARM_FEATURE_FP16_VECTOR_ARITHMETIC is undefined
-    if env['os'] == 'linux':
-        prefix = "aarch64-linux-gnu-"
-    elif env['os'] == 'bare_metal':
-        prefix = "aarch64-elf-"
-    elif env['os'] == 'android':
-        prefix = "aarch64-linux-android-"
-    env.Append(CPPDEFINES = ['ARM_COMPUTE_AARCH64_V8_2'])
-elif env['arch'] == 'x86_32':
-    env.Append(CCFLAGS = ['-m32'])
-    env.Append(LINKFLAGS = ['-m32'])
-elif env['arch'] == 'x86_64':
-    env.Append(CXXFLAGS = ['-fPIC'])
-    env.Append(CCFLAGS = ['-m64'])
-    env.Append(LINKFLAGS = ['-m64'])
+    else:
+        env.Append(CXXFLAGS = ['-march=armv8-a'])
+
+    if 'v8.6-a' in env['arch']:
+        env.Append(CPPDEFINES = ['MMLA_INT8', 'MMLA_FP32', 'V8P6', 'V8P6_BF', 'ARM_COMPUTE_FORCE_BF16'])
+
+elif 'x86' in env['arch']:
+    if env['estate'] == '32':
+        env.Append(CCFLAGS = ['-m32'])
+        env.Append(LINKFLAGS = ['-m32'])
+    else:
+        env.Append(CXXFLAGS = ['-fPIC'])
+        env.Append(CCFLAGS = ['-m64'])
+        env.Append(LINKFLAGS = ['-m64'])
+
+# Define toolchain
+prefix = ""
+if 'x86' not in env['arch']:
+    if env['estate'] == '32':
+        if env['os'] == 'linux':
+            prefix = "arm-linux-gnueabihf-" if 'v7' in env['arch'] else "armv8l-linux-gnueabihf-"
+        elif env['os'] == 'bare_metal':
+            prefix = "arm-eabi-"
+        elif env['os'] == 'android':
+            prefix = "arm-linux-androideabi-"
+        elif env['os'] == 'tizen':
+            prefix = "armv7l-tizen-linux-gnueabi-"
+    elif env['estate'] == '64' and 'v8' in env['arch']:
+        if env['os'] == 'linux':
+            prefix = "aarch64-linux-gnu-"
+        elif env['os'] == 'bare_metal':
+            prefix = "aarch64-elf-"
+        elif env['os'] == 'android':
+            prefix = "aarch64-linux-android-"
+        elif env['os'] == 'tizen':
+            prefix = "aarch64-tizen-linux-gnu-"
 
 if env['build'] == 'native':
     prefix = ""
@@ -211,8 +243,12 @@
 if env["toolchain_prefix"] != "":
     prefix = env["toolchain_prefix"]
 
-env['CC'] = env['compiler_cache']+" "+prefix + c_compiler
-env['CXX'] = env['compiler_cache']+" "+prefix + cpp_compiler
+compiler_prefix = prefix
+if env["compiler_prefix"] != "":
+    compiler_prefix = env["compiler_prefix"]
+
+env['CC'] = env['compiler_cache']+ " " + compiler_prefix + c_compiler
+env['CXX'] = env['compiler_cache']+ " " + compiler_prefix + cpp_compiler
 env['LD'] = prefix + "ld"
 env['AS'] = prefix + "as"
 env['AR'] = prefix + "ar"
@@ -250,48 +286,9 @@
 
 if env['os'] == 'android':
     env.Append(CPPDEFINES = ['ANDROID'])
-    env.Append(LINKFLAGS = ['-pie', '-static-libstdc++'])
+    env.Append(LINKFLAGS = ['-pie', '-static-libstdc++', '-ldl'])
 elif env['os'] == 'bare_metal':
     env.Append(LINKFLAGS = ['-static'])
     env.Append(LINKFLAGS = ['-specs=rdimon.specs'])
     env.Append(CXXFLAGS = ['-fPIC'])
     env.Append(CPPDEFINES = ['NO_MULTI_THREADING'])
-    env.Append(CPPDEFINES = ['BARE_METAL'])
-
-if env['opencl']:
-    if env['os'] in ['bare_metal'] or env['standalone']:
-        print("Cannot link OpenCL statically, which is required for bare metal / standalone builds")
-        Exit(1)
-
-if env['gles_compute']:
-    if env['os'] in ['bare_metal'] or env['standalone']:
-        print("Cannot link OpenGLES statically, which is required for bare metal / standalone builds")
-        Exit(1)
-
-if env["os"] not in ["android", "bare_metal"] and (env['opencl'] or env['cppthreads']):
-    env.Append(LIBS = ['pthread'])
-
-if env['opencl'] or env['gles_compute']:
-    if env['embed_kernels']:
-        env.Append(CPPDEFINES = ['EMBEDDED_KERNELS'])
-
-if env['debug']:
-    env['asserts'] = True
-    env['logging'] = True
-    env.Append(CXXFLAGS = ['-O0','-g','-gdwarf-2'])
-    env.Append(CPPDEFINES = ['ARM_COMPUTE_DEBUG_ENABLED'])
-else:
-    env.Append(CXXFLAGS = ['-O3'])
-
-if env['asserts']:
-    env.Append(CPPDEFINES = ['ARM_COMPUTE_ASSERTS_ENABLED'])
-    env.Append(CXXFLAGS = ['-fstack-protector-strong'])
-
-if env['logging']:
-    env.Append(CPPDEFINES = ['ARM_COMPUTE_LOGGING_ENABLED'])
-
-env.Append(CPPPATH = ['#/include', "#"])
-env.Append(CXXFLAGS = env['extra_cxx_flags'])
-env.Append(LINKFLAGS = env['extra_link_flags'])
-
-Default( install_include("arm_compute"))

=== debian/changelog ===
arm-compute-library (20.08+dfsg-7) unstable; urgency=medium

  * Actually include d/patches/missing-includes.patch, all changes to d/patches
    got removed by dgit.

 -- Emanuele Rocca <ema@debian.org>  Fri, 03 Mar 2023 14:31:21 +0100

arm-compute-library (20.08+dfsg-6) unstable; urgency=medium

  * Add d/patches/missing-includes.patch to fix FTBFS (Closes: #1032041)
  * Add myself to Uploaders with Wookey's permission.

 -- Emanuele Rocca <ema@debian.org>  Fri, 03 Mar 2023 14:12:26 +0100

arm-compute-library (20.08+dfsg-5) unstable; urgency=medium

  * Re-release as source-only upload

 -- Compute Library Team <developer-compute@arm.com>  Fri, 06 Nov 2020 00:30:42 +0000

arm-compute-library (20.08+dfsg-4) unstable; urgency=medium

  * Install library files in libarm-compute20

 -- Compute Library Team <developer-compute@arm.com>  Wed, 04 Nov 2020 04:01:19 +0000

arm-compute-library (20.08+dfsg-3) unstable; urgency=medium

  * Correct -dev package dependencies for SONAME 20

 -- Wookey <wookey@debian.org>  Mon, 02 Nov 2020 23:18:32 +0000

arm-compute-library (20.08+dfsg-2) unstable; urgency=medium

  * Dgit retry

 -- Compute Library Team <developer-compute@arm.com>  Sun, 01 Nov 2020 22:51:48 +0000

arm-compute-library (20.08+dfsg-1) unstable; urgency=medium

  * New upstream release

 -- Compute Library Team <developer-compute@arm.com>  Fri, 30 Oct 2020 02:50:53 +0000

arm-compute-library (19.11-3) unstable; urgency=medium

  * Fix arch check logic to allow arch-indep build on any architecture

 -- Compute Library Team <developer-compute@arm.com>  Thu, 24 Sep 2020 17:49:17 +0100

arm-compute-library (19.11-2) unstable; urgency=medium

  * Bump Standards, source-only upload
  * Assorted lintian fixes

 -- Compute Library Team <developer-compute@arm.com>  Thu, 17 Sep 2020 17:49:17 +0100

=== debian/control ===
--- 
+++ 
@@ -2,16 +2,18 @@
 Section: libs
 Priority: optional
 Maintainer: Compute Library Team <developer-compute@arm.com>
-Uploaders: Georgios Pinitas <georgios.pinitas@arm.com>,
-Standards-Version: 4.3.0
+Uploaders: Georgios Pinitas <georgios.pinitas@arm.com>, Emanuele Rocca <ema@debian.org>
+Standards-Version: 4.5.0
 Homepage: https://github.com/ARM-software/ComputeLibrary
+Vcs-git: https://salsa.debian.org/wookey/arm-compute-library
+Rules-Requires-Root: no
 Build-Depends: debhelper-compat (= 12),
                dh-exec (>=0.3),
                scons (>= 2.4),
                doxygen,
                graphviz
 
-Package: libarm-compute17
+Package: libarm-compute20
 Architecture: armhf arm64
 Multi-Arch: same
 Depends: ${shlibs:Depends}, ${misc:Depends}
@@ -29,7 +31,7 @@
 Section: libdevel
 Architecture: armhf arm64
 Multi-Arch: same
-Depends: libarm-compute17 (= ${binary:Version}), ${misc:Depends}
+Depends: libarm-compute20 (= ${binary:Version}), ${misc:Depends}
 Suggests: libarm-compute-doc (= ${source:Version})
 Description: Arm Compute Library - development files
  Arm Compute Library is a software library for computer vision and

=== debian/watch ===
# Compulsory line, this is a version 4 file
version=4

opts=filenamemangle=s/.+\/v?(\d\S+)\.zip/ComputeLibrary-$1\.zip/ \
  https://github.com/Arm-software/ComputeLibrary/tags .*/v?(\d\S+)\.zip
